diff --git a/fc-solve/source/dbm_calc_derived.h b/fc-solve/source/dbm_calc_derived.h
index f50b17cf1..579f90728 100644
--- a/fc-solve/source/dbm_calc_derived.h
+++ b/fc-solve/source/dbm_calc_derived.h
@@ -203,387 +206,393 @@ static inline fcs_fcc_moves_list_item_t *fc_solve_fcc_alloc_moves_list_item(
             : fcs_is_parent_card(card, fcs_col_get_card(col, cards_num - 2)))
 #define COUNT_NON_REV(is_reversible) ((is_reversible) ? 1 : 2)
 
-/* Returns the number of amortized irreversible moves performed. */
-static inline int horne_prune(const fcs_dbm_variant_type_t local_variant,
-    fcs_state_keyval_pair_t *const init_state_kv_ptr,
-    fcs_which_moves_bitmask_t *const which_irreversible_moves_bitmask,
-    fcs_fcc_moves_seq_t *const moves_seq,
-    fcs_fcc_moves_seq_allocator_t *const allocator)
-{
-    fcs_fcc_move_t additional_moves[RANK_KING * 4 * DECKS_NUM];
-    int count_moves_so_far = 0;
-    int count_additional_irrev_moves = 0;
+    /* Returns the number of amortized irreversible moves performed. */
+    static inline int horne_prune(const fcs_dbm_variant_type_t local_variant,
+        fcs_state_keyval_pair_t *const init_state_kv_ptr,
+        fcs_which_moves_bitmask_t *const which_irreversible_moves_bitmask,
+        fcs_fcc_moves_seq_t *const moves_seq,
+        fcs_fcc_moves_seq_allocator_t *const allocator)
+    {
+        fcs_fcc_move_t additional_moves[RANK_KING * 4 * DECKS_NUM];
+        int count_moves_so_far = 0;
+        int count_additional_irrev_moves = 0;
 #ifndef FCS_FREECELL_ONLY
-    const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
+        const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
 #endif
 
 #define the_state (init_state_kv_ptr->s)
-    uint_fast32_t num_cards_moved;
-    do
-    {
-        num_cards_moved = 0;
-        for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
+        uint_fast32_t num_cards_moved;
+        do
         {
-            var_AUTO(col, fcs_state_get_col(the_state, stack_idx));
-            const int cards_num = fcs_col_len(col);
-            if (!cards_num)
-            {
-                continue;
-            }
-            /* Get the top card in the stack */
-            const fcs_card_t card = fcs_col_get_card(col, cards_num - 1);
-            const int dest_foundation =
-                calc_foundation_to_put_card_on(local_variant, &the_state, card);
-            if (dest_foundation >= 0)
+            num_cards_moved = 0;
+            for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
             {
-                const_AUTO(is_reversible, FROM_COL_IS_REVERSIBLE_MOVE());
-                if (!is_reversible)
+                var_AUTO(col, fcs_state_get_col(the_state, stack_idx));
+                const int cards_num = fcs_col_len(col);
+                if (!cards_num)
                 {
-                    count_additional_irrev_moves++;
+                    continue;
                 }
-                /* We can safely move it. */
-                num_cards_moved++;
-                fc_solve_add_to_irrev_moves_bitmask(
-                    which_irreversible_moves_bitmask, card,
-                    COUNT_NON_REV(is_reversible));
-
-                fcs_col_pop_top(col);
-
-                fcs_increment_foundation(the_state, dest_foundation);
-
-                additional_moves[count_moves_so_far++] =
-                    MAKE_MOVE(COL2MOVE(stack_idx), FOUND2MOVE(dest_foundation));
-            }
-        }
-
-        /* Now check the same for the free cells */
-        for (int fc = 0; fc < LOCAL_FREECELLS_NUM; fc++)
-        {
-            const fcs_card_t card = fcs_freecell_card(the_state, fc);
-            if (fcs_card_is_valid(card))
-            {
+                /* Get the top card in the stack */
+                const fcs_card_t card = fcs_col_get_card(col, cards_num - 1);
                 const int dest_foundation = calc_foundation_to_put_card_on(
                     local_variant, &the_state, card);
                 if (dest_foundation >= 0)
                 {
+                    const_AUTO(is_reversible, FROM_COL_IS_REVERSIBLE_MOVE());
+                    if (!is_reversible)
+                    {
+                        count_additional_irrev_moves++;
+                    }
+                    /* We can safely move it. */
                     num_cards_moved++;
                     fc_solve_add_to_irrev_moves_bitmask(
-                        which_irreversible_moves_bitmask, card, 1);
+                        which_irreversible_moves_bitmask, card,
+                        COUNT_NON_REV(is_reversible));
 
-                    /* We can put it there */
+                    fcs_col_pop_top(col);
 
-                    fcs_empty_freecell(the_state, fc);
                     fcs_increment_foundation(the_state, dest_foundation);
-                    additional_moves[count_moves_so_far++] =
-                        MAKE_MOVE(COL2MOVE(fc), FOUND2MOVE(dest_foundation));
+
+                    additional_moves[count_moves_so_far++] = MAKE_MOVE(
+                        COL2MOVE(stack_idx), FOUND2MOVE(dest_foundation));
                 }
             }
-        }
-    } while (num_cards_moved);
-
-    /* modify moves_seq in-place. */
-    if (count_moves_so_far && moves_seq)
-    {
-        fcs_fcc_moves_list_item_t **iter = &(moves_seq->moves_list);
-
-        /* Assuming FCS_FCC_NUM_MOVES_IN_ITEM is 8 and we want (*iter)
-         * to point at the place to either write the new moves or
-         * alternatively (on parity) on the pointer to allocate a new
-         * list_item for the moves.
-         *
-         * If count is 0, then we should move 0.
-         * If count is 1, then we should move 0.
-         * .
-         * .
-         * .
-         * If count is 7, then we should move 0.
-         * If count is 8, then we should move 1 time.
-         *
-         * to sum up we need to move count / FCS_FCC_NUM_MOVES_IN_ITEM .
-         *
-         * */
-        const int count = moves_seq->count;
-        for (int pos = 0; pos <= count - FCS_FCC_NUM_MOVES_IN_ITEM;
-             pos += FCS_FCC_NUM_MOVES_IN_ITEM)
-        {
-            iter = &((*iter)->next);
-        }
-
-        int pos = count;
 
-        for (int pos_moves_so_far = 0; pos_moves_so_far < count_moves_so_far;
-             pos_moves_so_far++)
-        {
-            if (pos % FCS_FCC_NUM_MOVES_IN_ITEM == 0)
+            /* Now check the same for the free cells */
+            for (int fc = 0; fc < LOCAL_FREECELLS_NUM; fc++)
             {
-                (*iter) = fc_solve_fcc_alloc_moves_list_item(allocator);
+                const fcs_card_t card = fcs_freecell_card(the_state, fc);
+                if (fcs_card_is_valid(card))
+                {
+                    const int dest_foundation = calc_foundation_to_put_card_on(
+                        local_variant, &the_state, card);
+                    if (dest_foundation >= 0)
+                    {
+                        num_cards_moved++;
+                        fc_solve_add_to_irrev_moves_bitmask(
+                            which_irreversible_moves_bitmask, card, 1);
+
+                        /* We can put it there */
+
+                        fcs_empty_freecell(the_state, fc);
+                        fcs_increment_foundation(the_state, dest_foundation);
+                        additional_moves[count_moves_so_far++] = MAKE_MOVE(
+                            COL2MOVE(fc), FOUND2MOVE(dest_foundation));
+                    }
+                }
             }
-            (*iter)->data.s[pos % FCS_FCC_NUM_MOVES_IN_ITEM] =
-                additional_moves[pos_moves_so_far];
-            if ((++pos) % FCS_FCC_NUM_MOVES_IN_ITEM == 0)
+        } while (num_cards_moved);
+
+        /* modify moves_seq in-place. */
+        if (count_moves_so_far && moves_seq)
+        {
+            fcs_fcc_moves_list_item_t **iter = &(moves_seq->moves_list);
+
+            /* Assuming FCS_FCC_NUM_MOVES_IN_ITEM is 8 and we want (*iter)
+             * to point at the place to either write the new moves or
+             * alternatively (on parity) on the pointer to allocate a new
+             * list_item for the moves.
+             *
+             * If count is 0, then we should move 0.
+             * If count is 1, then we should move 0.
+             * .
+             * .
+             * .
+             * If count is 7, then we should move 0.
+             * If count is 8, then we should move 1 time.
+             *
+             * to sum up we need to move count / FCS_FCC_NUM_MOVES_IN_ITEM .
+             *
+             * */
+            const int count = moves_seq->count;
+            for (int pos = 0; pos <= count - FCS_FCC_NUM_MOVES_IN_ITEM;
+                 pos += FCS_FCC_NUM_MOVES_IN_ITEM)
             {
                 iter = &((*iter)->next);
             }
-        }
-        moves_seq->count += count_moves_so_far;
-    }
-
-    return count_moves_so_far + count_additional_irrev_moves;
-}
-
-static inline int horne_prune__simple(
-    const fcs_dbm_variant_type_t local_variant,
-    fcs_state_keyval_pair_t *const init_state_kv_ptr)
-{
-    fcs_which_moves_bitmask_t no_use = {{'\0'}};
-    return horne_prune(local_variant, init_state_kv_ptr, &no_use, NULL, NULL);
-}
 
-static inline fcs_bool_t card_cannot_be_placed(const fcs_state_t *const s,
-    const uint16_t ds, const fcs_card_t card, const int sequences_are_built_by)
-{
-    const_AUTO(col, fcs_state_get_col(*s, ds));
-    const_AUTO(col_len, fcs_col_len(col));
-    return ((col_len == 0) ||
-            (!fcs_is_parent_card(card, fcs_col_get_card(col, col_len - 1))));
-}
+            int pos = count;
 
-#define the_state (init_state_kv_ptr->s)
-static inline fcs_bool_t is_state_solved(
-    fcs_state_keyval_pair_t *const init_state_kv_ptr)
-{
-    for (int suit = 0; suit < DECKS_NUM * 4; suit++)
-    {
-        if (fcs_foundation_value(the_state, suit) < RANK_KING)
-        {
-            return FALSE;
+            for (int pos_moves_so_far = 0;
+                 pos_moves_so_far < count_moves_so_far; pos_moves_so_far++)
+            {
+                if (pos % FCS_FCC_NUM_MOVES_IN_ITEM == 0)
+                {
+                    (*iter) = fc_solve_fcc_alloc_moves_list_item(allocator);
+                }
+                (*iter)->data.s[pos % FCS_FCC_NUM_MOVES_IN_ITEM] =
+                    additional_moves[pos_moves_so_far];
+                if ((++pos) % FCS_FCC_NUM_MOVES_IN_ITEM == 0)
+                {
+                    iter = &((*iter)->next);
+                }
+            }
+            moves_seq->count += count_moves_so_far;
         }
+
+        return count_moves_so_far + count_additional_irrev_moves;
     }
-    return TRUE;
-}
 
-static inline fcs_bool_t instance_solver_thread_calc_derived_states(
-    const fcs_dbm_variant_type_t local_variant,
-    fcs_state_keyval_pair_t *const init_state_kv_ptr,
-    fcs_dbm_record_t *const parent_ptr,
-    fcs_derived_state_t **const derived_list,
-    fcs_derived_state_t **const derived_list_recycle_bin,
-    fcs_compact_allocator_t *const derived_list_allocator,
-    const fcs_bool_t perform_horne_prune)
-{
-    fcs_derived_state_t *ptr_new_state;
-    int empty_stack_idx = -1;
-    const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
-#define new_state (ptr_new_state->state.s)
-    if (is_state_solved(init_state_kv_ptr))
+    static inline int horne_prune__simple(
+        const fcs_dbm_variant_type_t local_variant,
+        fcs_state_keyval_pair_t *const init_state_kv_ptr)
     {
-        return TRUE;
+        fcs_which_moves_bitmask_t no_use = {{'\0'}};
+        return horne_prune(
+            local_variant, init_state_kv_ptr, &no_use, NULL, NULL);
     }
 
-    /* Move top stack cards to foundations. */
-    for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
+    static inline fcs_bool_t card_cannot_be_placed(const fcs_state_t *const s,
+        const uint16_t ds, const fcs_card_t card,
+        const int sequences_are_built_by)
     {
-        const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
-        const_AUTO(cards_num, fcs_col_len(col));
-        if (cards_num == 0)
-        {
-            empty_stack_idx = stack_idx;
-            continue;
-        }
-        /* Get the top card in the stack */
-        const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
-        const_AUTO(suit, fcs_card_suit(card));
-        for (int deck = 0; deck < INSTANCE_DECKS_NUM; deck++)
-        {
-            if (fcs_foundation_value(the_state, deck * 4 + suit) !=
-                fcs_card_rank(card) - 1)
-            {
-                continue;
-            }
-            /* We can put it there */
-            BEGIN_NEW_STATE()
-
-            fcs_state_pop_col_top(&new_state, stack_idx);
-            fcs_increment_foundation(new_state, deck * 4 + suit);
-
-            COMMIT_NEW_STATE_WITH_COUNT(COL2MOVE(stack_idx), FOUND2MOVE(suit),
-                COUNT_NON_REV(FROM_COL_IS_REVERSIBLE_MOVE()), card)
-            break;
-        }
+        const_AUTO(col, fcs_state_get_col(*s, ds));
+        const_AUTO(col_len, fcs_col_len(col));
+        return ((col_len == 0) || (!fcs_is_parent_card(card,
+                                      fcs_col_get_card(col, col_len - 1))));
     }
 
-    int empty_fc_idx = -1;
-    /* Move freecell cards to foundations. */
-    for (int fc_idx = 0; fc_idx < LOCAL_FREECELLS_NUM; fc_idx++)
+#define the_state (init_state_kv_ptr->s)
+    static inline fcs_bool_t is_state_solved(
+        fcs_state_keyval_pair_t *const init_state_kv_ptr)
     {
-        const_AUTO(card, fcs_freecell_card(the_state, fc_idx));
-        if (fcs_card_is_empty(card))
-        {
-            empty_fc_idx = fc_idx;
-            continue;
-        }
-        const_AUTO(suit, fcs_card_suit(card));
-        for (int deck = 0; deck < INSTANCE_DECKS_NUM; deck++)
+        for (int suit = 0; suit < DECKS_NUM * 4; suit++)
         {
-            if (fcs_foundation_value(the_state, deck * 4 + suit) !=
-                fcs_card_rank(card) - 1)
+            if (fcs_foundation_value(the_state, suit) < RANK_KING)
             {
-                continue;
+                return FALSE;
             }
-            BEGIN_NEW_STATE()
-
-            /* We can put it there */
-            fcs_empty_freecell(new_state, fc_idx);
-            fcs_increment_foundation(new_state, deck * 4 + suit);
-
-            COMMIT_NEW_STATE(
-                FREECELL2MOVE(fc_idx), FOUND2MOVE(suit), FALSE, card)
-            break;
         }
+        return TRUE;
     }
 
-    const int cards_num_min_limit =
-        ((local_variant == FCS_DBM_VARIANT_BAKERS_DOZEN) ? 1 : 0);
-
-    /* Move stack card on top of a parent */
-    for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
+    static inline fcs_bool_t instance_solver_thread_calc_derived_states(
+        const fcs_dbm_variant_type_t local_variant,
+        fcs_state_keyval_pair_t *const init_state_kv_ptr,
+        fcs_dbm_record_t *const parent_ptr,
+        fcs_derived_state_t **const derived_list,
+        fcs_derived_state_t **const derived_list_recycle_bin,
+        fcs_compact_allocator_t *const derived_list_allocator,
+        const fcs_bool_t perform_horne_prune)
     {
-        const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
-        const_AUTO(cards_num, fcs_col_len(col));
-        if (cards_num <= cards_num_min_limit)
+        fcs_derived_state_t *ptr_new_state;
+        int empty_stack_idx = -1;
+        const int sequences_are_built_by = CALC_SEQUENCES_ARE_BUILT_BY();
+#define new_state (ptr_new_state->state.s)
+        if (is_state_solved(init_state_kv_ptr))
         {
-            continue;
+            return TRUE;
         }
-        const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
 
-        for (int ds = 0; ds < LOCAL_STACKS_NUM; ++ds)
+        /* Move top stack cards to foundations. */
+        for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
         {
-            if (ds == stack_idx || card_cannot_be_placed(&the_state, ds, card,
-                                       sequences_are_built_by))
+            const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
+            const_AUTO(cards_num, fcs_col_len(col));
+            if (cards_num == 0)
             {
+                empty_stack_idx = stack_idx;
                 continue;
             }
-            /* Let's move it */
-            BEGIN_NEW_STATE()
+            /* Get the top card in the stack */
+            const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
+            const_AUTO(suit, fcs_card_suit(card));
+            for (int deck = 0; deck < INSTANCE_DECKS_NUM; deck++)
+            {
+                if (fcs_foundation_value(the_state, deck * 4 + suit) !=
+                    fcs_card_rank(card) - 1)
+                {
+                    continue;
+                }
+                /* We can put it there */
+                BEGIN_NEW_STATE()
 
-            fcs_state_pop_col_top(&new_state, stack_idx);
-            fcs_state_push(&new_state, ds, card);
+                fcs_state_pop_col_top(&new_state, stack_idx);
+                fcs_increment_foundation(new_state, deck * 4 + suit);
 
-            COMMIT_NEW_STATE(COL2MOVE(stack_idx), COL2MOVE(ds),
-                FROM_COL_IS_REVERSIBLE_MOVE(), card)
+                COMMIT_NEW_STATE_WITH_COUNT(COL2MOVE(stack_idx),
+                    FOUND2MOVE(suit),
+                    COUNT_NON_REV(FROM_COL_IS_REVERSIBLE_MOVE()), card)
+                break;
+            }
         }
-    }
 
-    /* Move freecell card on top of a parent */
-    for (int fc_idx = 0; fc_idx < LOCAL_FREECELLS_NUM; fc_idx++)
-    {
-        const_AUTO(card, fcs_freecell_card(the_state, fc_idx));
-        if (!fcs_card_is_valid(card))
-        {
-            continue;
-        }
-        for (int ds = 0; ds < LOCAL_STACKS_NUM; ++ds)
+        int empty_fc_idx = -1;
+        /* Move freecell cards to foundations. */
+        for (int fc_idx = 0; fc_idx < LOCAL_FREECELLS_NUM; fc_idx++)
         {
-            if (card_cannot_be_placed(
-                    &the_state, ds, card, sequences_are_built_by))
+            const_AUTO(card, fcs_freecell_card(the_state, fc_idx));
+            if (fcs_card_is_empty(card))
             {
+                empty_fc_idx = fc_idx;
                 continue;
             }
-            /* Let's move it */
-            BEGIN_NEW_STATE()
+            const_AUTO(suit, fcs_card_suit(card));
+            for (int deck = 0; deck < INSTANCE_DECKS_NUM; deck++)
+            {
+                if (fcs_foundation_value(the_state, deck * 4 + suit) !=
+                    fcs_card_rank(card) - 1)
+                {
+                    continue;
+                }
+                BEGIN_NEW_STATE()
 
-            fcs_state_push(&new_state, ds, card);
-            fcs_empty_freecell(new_state, fc_idx);
+                /* We can put it there */
+                fcs_empty_freecell(new_state, fc_idx);
+                fcs_increment_foundation(new_state, deck * 4 + suit);
 
-            COMMIT_NEW_STATE(FREECELL2MOVE(fc_idx), COL2MOVE(ds), TRUE, card)
+                COMMIT_NEW_STATE(
+                    FREECELL2MOVE(fc_idx), FOUND2MOVE(suit), FALSE, card)
+                break;
+            }
         }
-    }
 
-    if ((local_variant != FCS_DBM_VARIANT_BAKERS_DOZEN) &&
-        (empty_stack_idx >= 0))
-    {
-        /* Stack Card to Empty Stack */
+        const int cards_num_min_limit =
+            ((local_variant == FCS_DBM_VARIANT_BAKERS_DOZEN) ? 1 : 0);
+
+        /* Move stack card on top of a parent */
         for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
         {
             const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
             const_AUTO(cards_num, fcs_col_len(col));
-            /* Bug fix: if there's only one card in a column, there's no
-             * point moving it to a new empty column.
-             * */
-            if (cards_num <= 1)
+            if (cards_num <= cards_num_min_limit)
             {
                 continue;
             }
-
             const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
-            /* Let's move it */
-            BEGIN_NEW_STATE()
 
-            fcs_state_pop_col_top(&new_state, stack_idx);
-            fcs_state_push(&new_state, empty_stack_idx, card);
+            for (int ds = 0; ds < LOCAL_STACKS_NUM; ++ds)
+            {
+                if (ds == stack_idx || card_cannot_be_placed(&the_state, ds,
+                                           card, sequences_are_built_by))
+                {
+                    continue;
+                }
+                /* Let's move it */
+                BEGIN_NEW_STATE()
+
+                fcs_state_pop_col_top(&new_state, stack_idx);
+                fcs_state_push(&new_state, ds, card);
 
-            COMMIT_NEW_STATE(COL2MOVE(stack_idx), COL2MOVE(empty_stack_idx),
-                FROM_COL_IS_REVERSIBLE_MOVE(), card)
+                COMMIT_NEW_STATE(COL2MOVE(stack_idx), COL2MOVE(ds),
+                    FROM_COL_IS_REVERSIBLE_MOVE(), card)
+            }
         }
 
-        /* Freecell card -> Empty Stack. */
+        /* Move freecell card on top of a parent */
         for (int fc_idx = 0; fc_idx < LOCAL_FREECELLS_NUM; fc_idx++)
         {
             const_AUTO(card, fcs_freecell_card(the_state, fc_idx));
-            if (fcs_card_is_empty(card))
+            if (!fcs_card_is_valid(card))
             {
                 continue;
             }
+            for (int ds = 0; ds < LOCAL_STACKS_NUM; ++ds)
+            {
+                if (card_cannot_be_placed(
+                        &the_state, ds, card, sequences_are_built_by))
+                {
+                    continue;
+                }
+                /* Let's move it */
+                BEGIN_NEW_STATE()
 
-            BEGIN_NEW_STATE()
-
-            fcs_state_push(&new_state, empty_stack_idx, card);
-            fcs_empty_freecell(new_state, fc_idx);
+                fcs_state_push(&new_state, ds, card);
+                fcs_empty_freecell(new_state, fc_idx);
 
-            COMMIT_NEW_STATE(
-                FREECELL2MOVE(fc_idx), COL2MOVE(empty_stack_idx), TRUE, card);
+                COMMIT_NEW_STATE(
+                    FREECELL2MOVE(fc_idx), COL2MOVE(ds), TRUE, card)
+            }
         }
-    }
 
-    if (empty_fc_idx >= 0)
-    {
-        /* Stack Card to Empty Freecell */
-        for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
+        if ((local_variant != FCS_DBM_VARIANT_BAKERS_DOZEN) &&
+            (empty_stack_idx >= 0))
         {
-            const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
-            const_AUTO(cards_num, fcs_col_len(col));
-            if (cards_num <= cards_num_min_limit)
+            /* Stack Card to Empty Stack */
+            for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
             {
-                continue;
+                const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
+                const_AUTO(cards_num, fcs_col_len(col));
+                /* Bug fix: if there's only one card in a column, there's no
+                 * point moving it to a new empty column.
+                 * */
+                if (cards_num <= 1)
+                {
+                    continue;
+                }
+
+                const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
+                /* Let's move it */
+                BEGIN_NEW_STATE()
+
+                fcs_state_pop_col_top(&new_state, stack_idx);
+                fcs_state_push(&new_state, empty_stack_idx, card);
+
+                COMMIT_NEW_STATE(COL2MOVE(stack_idx), COL2MOVE(empty_stack_idx),
+                    FROM_COL_IS_REVERSIBLE_MOVE(), card)
             }
-            const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
-            /* Let's move it */
-            BEGIN_NEW_STATE()
 
-            fcs_state_pop_col_top(&new_state, stack_idx);
-            fcs_put_card_in_freecell(new_state, empty_fc_idx, card);
+            /* Freecell card -> Empty Stack. */
+            for (int fc_idx = 0; fc_idx < LOCAL_FREECELLS_NUM; fc_idx++)
+            {
+                const_AUTO(card, fcs_freecell_card(the_state, fc_idx));
+                if (fcs_card_is_empty(card))
+                {
+                    continue;
+                }
+
+                BEGIN_NEW_STATE()
 
-            COMMIT_NEW_STATE(COL2MOVE(stack_idx), FREECELL2MOVE(empty_fc_idx),
-                FROM_COL_IS_REVERSIBLE_MOVE(), card)
+                fcs_state_push(&new_state, empty_stack_idx, card);
+                fcs_empty_freecell(new_state, fc_idx);
+
+                COMMIT_NEW_STATE(FREECELL2MOVE(fc_idx),
+                    COL2MOVE(empty_stack_idx), TRUE, card);
+            }
         }
-    }
-    /* Perform Horne's Prune on all the states,
-     * or just set their num irreversible moves counts.
-     * */
-    for (var_AUTO(derived_iter, *derived_list); derived_iter;
-         derived_iter = derived_iter->next)
-    {
-        derived_iter->num_non_reversible_moves_including_prune =
-            (derived_iter->core_irreversible_moves_count +
-                (perform_horne_prune
-                        ? horne_prune(local_variant, &(derived_iter->state),
-                              &(derived_iter->which_irreversible_moves_bitmask),
-                              NULL, NULL)
-                        : 0));
-    }
 
-    return FALSE;
-}
+        if (empty_fc_idx >= 0)
+        {
+            /* Stack Card to Empty Freecell */
+            for (int stack_idx = 0; stack_idx < LOCAL_STACKS_NUM; stack_idx++)
+            {
+                const_AUTO(col, fcs_state_get_col(the_state, stack_idx));
+                const_AUTO(cards_num, fcs_col_len(col));
+                if (cards_num <= cards_num_min_limit)
+                {
+                    continue;
+                }
+                const_AUTO(card, fcs_col_get_card(col, cards_num - 1));
+                /* Let's move it */
+                BEGIN_NEW_STATE()
+
+                fcs_state_pop_col_top(&new_state, stack_idx);
+                fcs_put_card_in_freecell(new_state, empty_fc_idx, card);
+
+                COMMIT_NEW_STATE(COL2MOVE(stack_idx),
+                    FREECELL2MOVE(empty_fc_idx), FROM_COL_IS_REVERSIBLE_MOVE(),
+                    card)
+            }
+        }
+        /* Perform Horne's Prune on all the states,
+         * or just set their num irreversible moves counts.
+         * */
+        for (var_AUTO(derived_iter, *derived_list); derived_iter;
+             derived_iter = derived_iter->next)
+        {
+            derived_iter->num_non_reversible_moves_including_prune =
+                (derived_iter->core_irreversible_moves_count +
+                    (perform_horne_prune
+                            ? horne_prune(local_variant, &(derived_iter->state),
+                                  &(derived_iter
+                                          ->which_irreversible_moves_bitmask),
+                                  NULL, NULL)
+                            : 0));
+        }
+
+        return FALSE;
+    }
 
 #undef FROM_COL_IS_REVERSIBLE_MOVE
 #undef COUNT_NON_REV
diff --git a/fc-solve/source/dbm_calc_derived_iface.h b/fc-solve/source/dbm_calc_derived_iface.h
index 7828c78f0..c646c0e43 100644
--- a/fc-solve/source/dbm_calc_derived_iface.h
+++ b/fc-solve/source/dbm_calc_derived_iface.h
@@ -13,41 +13,42 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include "dbm_common.h"
 
-typedef struct
-{
-    unsigned char s[RANK_KING];
-} fcs_which_moves_bitmask_t;
-
-typedef struct
-{
-    char *state_string;
-    unsigned char move;
-    int core_irreversible_moves_count;
-    int num_non_reversible_moves_including_prune;
-    fcs_which_moves_bitmask_t which_irreversible_moves_bitmask;
-} fcs_derived_state_debug_t;
-
-DLLEXPORT int fc_solve_user_INTERNAL_calc_derived_states_wrapper(
-    fcs_dbm_variant_type_t, const char *, int *, fcs_derived_state_debug_t **,
-    fcs_bool_t);
-
-DLLEXPORT void fc_solve_user_INTERNAL_free_derived_states(
-    const int num_derived_states,
-    fcs_derived_state_debug_t *const derived_states);
-
-/*
- * The char * returned is malloc()ed and should be free()ed.
- */
-DLLEXPORT int fc_solve_user_INTERNAL_perform_horne_prune(
-    fcs_dbm_variant_type_t, const char *, char **);
-
-DLLEXPORT void fc_solve_user_INTERNAL_perform_horne_prune__free_ret_state_s(
-    char *const ret_state_s);
+    typedef struct
+    {
+        unsigned char s[RANK_KING];
+    } fcs_which_moves_bitmask_t;
+
+    typedef struct
+    {
+        char *state_string;
+        unsigned char move;
+        int core_irreversible_moves_count;
+        int num_non_reversible_moves_including_prune;
+        fcs_which_moves_bitmask_t which_irreversible_moves_bitmask;
+    } fcs_derived_state_debug_t;
+
+    DLLEXPORT int fc_solve_user_INTERNAL_calc_derived_states_wrapper(
+        fcs_dbm_variant_type_t, const char *, int *,
+        fcs_derived_state_debug_t **, fcs_bool_t);
+
+    DLLEXPORT void fc_solve_user_INTERNAL_free_derived_states(
+        const int num_derived_states,
+        fcs_derived_state_debug_t *const derived_states);
+
+    /*
+     * The char * returned is malloc()ed and should be free()ed.
+     */
+    DLLEXPORT int fc_solve_user_INTERNAL_perform_horne_prune(
+        fcs_dbm_variant_type_t, const char *, char **);
+
+    DLLEXPORT void fc_solve_user_INTERNAL_perform_horne_prune__free_ret_state_s(
+        char *const ret_state_s);
 
 #ifdef __cplusplus
 }
diff --git a/fc-solve/source/dbm_common.h b/fc-solve/source/dbm_common.h
index 6951b4e2a..f3bbb6e9d 100644
--- a/fc-solve/source/dbm_common.h
+++ b/fc-solve/source/dbm_common.h
@@ -11,15 +11,17 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include "state.h"
 
-typedef enum {
-    FCS_DBM_VARIANT_2FC_FREECELL,
-    FCS_DBM_VARIANT_BAKERS_DOZEN,
-} fcs_dbm_variant_type_t;
+    typedef enum
+    {
+        FCS_DBM_VARIANT_2FC_FREECELL,
+        FCS_DBM_VARIANT_BAKERS_DOZEN,
+    } fcs_dbm_variant_type_t;
 
 #ifndef FCS_DBM_FREECELLS_NUM
 #define FCS_DBM_FREECELLS_NUM 2
diff --git a/fc-solve/source/dbm_kaztree_compare.h b/fc-solve/source/dbm_kaztree_compare.h
index e40c3e700..a181a1a4f 100644
--- a/fc-solve/source/dbm_kaztree_compare.h
+++ b/fc-solve/source/dbm_kaztree_compare.h
@@ -16,33 +16,34 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include "delta_states.h"
 
 #if defined(FCS_DBM_RECORD_POINTER_REPR) && (!defined(FCS_DEBONDT_DELTA_STATES))
-static int compare_records(
-    const void *const void_a, const void *const void_b, void *const context)
-{
+    static int compare_records(
+        const void *const void_a, const void *const void_b, void *const context)
+    {
 #define GET_PARAM(p) (&(((const fcs_dbm_record_t *)(p))->key))
-    const fcs_encoded_state_buffer_t *const a = GET_PARAM(void_a),
-                                            *const b = GET_PARAM(void_b);
+        const fcs_encoded_state_buffer_t *const a = GET_PARAM(void_a),
+                                                *const b = GET_PARAM(void_b);
 #undef GET_PARAM
 
-    if (a->s[0] < b->s[0])
-    {
-        return -1;
+        if (a->s[0] < b->s[0])
+        {
+            return -1;
+        }
+        else if (a->s[0] > b->s[0])
+        {
+            return 1;
+        }
+        else
+        {
+            return memcmp(a->s, b->s, a->s[0] + 1);
+        }
     }
-    else if (a->s[0] > b->s[0])
-    {
-        return 1;
-    }
-    else
-    {
-        return memcmp(a->s, b->s, a->s[0] + 1);
-    }
-}
 #else
 static int compare_records(const void *const void_a, const void *const void_b,
     void *const context GCC_UNUSED)
